using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Runtime.InteropServices;


namespace IO
{
    public partial class Form1 : Form
    {
        /// <summary>
        /// TuAChCxg
        /// </summary>
        event System.EventHandler SubIdle;
        
        public Form1()
        {
            InitializeComponent();
        }

        #region Win32 API
        /// <summary>Windows Message</summary>
        [StructLayout(LayoutKind.Sequential)]
        public struct Message
        {
            public IntPtr hWnd;
            public Int32 msg;
            public IntPtr wParam;
            public IntPtr lParam;
            public uint time;
            public System.Drawing.Point p;
        }

        [System.Security.SuppressUnmanagedCodeSecurity]
        [DllImport("User32.dll", CharSet = CharSet.Auto)]
        public static extern bool PeekMessage(out Message msg, IntPtr hWnd, uint messageFilterMin, uint messageFilterMax, uint flags);

        [System.Security.SuppressUnmanagedCodeSecurity]
        [DllImport("kernel32")]
        public static extern bool QueryPerformanceFrequency(out long PerformanceFrequency);

        [System.Security.SuppressUnmanagedCodeSecurity]
        [DllImport("kernel32")]
        public static extern bool QueryPerformanceCounter(out long PerformanceCount);

        private bool AppStillIdle
        {
            get
            {
                Message msg;
                return !PeekMessage(out msg, IntPtr.Zero, 0, 0, 0);
            }
        }
        #endregion

        public void OnApplicationIdle(object sender, EventArgs e)
        {
            // tH[\ĂȂꍇ͕`悵Ȃ
            if (!this.Visible) return;

            // tH[ŏĂꍇ͕`悵Ȃ
            if (this.WindowState == FormWindowState.Minimized) return;

            // ACh[v
            while (AppStillIdle)
            {
                // TuAChCxgs
                if (SubIdle != null)
                    SubIdle(sender, e);

                // CPUׂ邽߃EFCg
                System.Threading.Thread.Sleep(1);
            }
        }

        string textureImageFile = null;

        private void openTextureImageMenu_Click(object sender, EventArgs e)
        {
            using (CustomControls.OpenTextureDialog controlex = new CustomControls.OpenTextureDialog(false,null))
            {
                controlex.StartLocation = CustomControls.Controls.AddonWindowLocation.Right;
                controlex.DefaultViewMode = CustomControls.OS.FolderViewMode.Thumbnails;
                controlex.OpenDialog.AddExtension = true;
                controlex.OpenDialog.InitialDirectory = Path.Combine(Application.StartupPath,"textures");
                controlex.OpenDialog.Filter = "TextureImage File |*.bmp;*.gif;*.jpeg;*.jpg;*.png;*.tif;*.tiff;*.tga;*.dds;*.hdr;*.exr";
                if (controlex.ShowDialog(this) == DialogResult.OK)
                {
                    textureImageFile = controlex.OpenDialog.FileName;
                }
            }
        }

        private void openNormalMapImageMenu_Click(object sender, EventArgs e)
        {
            using (CustomControls.OpenTextureDialog controlex = new CustomControls.OpenTextureDialog(true,textureImageFile))
            {
                controlex.StartLocation = CustomControls.Controls.AddonWindowLocation.Right;
                controlex.DefaultViewMode = CustomControls.OS.FolderViewMode.Thumbnails;
                controlex.OpenDialog.AddExtension = true;
                controlex.OpenDialog.InitialDirectory = Path.Combine(Application.StartupPath,"normalmaps");
                controlex.OpenDialog.Filter = "NormalMap File |*.bmp;*.gif;*.jpeg;*.jpg;*.png;*.tif;*.tiff;*.tga;*.dds;*.hdr;*.exr";
                if (controlex.ShowDialog(this) == DialogResult.OK)
                {
                }
            }
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}